Package weka.filters.unsupervised.attribute

# Class AddNoise

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.attribute.AddNoise

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `CapabilitiesIgnorer`, `CommandlineRunnable`, `OptionHandler`, `Randomizable`, `RevisionHandler`, `WeightedAttributesHandler`, `UnsupervisedFilter`

public class AddNoise extends Filter implements UnsupervisedFilter, OptionHandler, Randomizable, WeightedAttributesHandler
An instance filter that changes a percentage of a given attribute's values. The attribute must be nominal. Missing value can be treated as a distinct separate value.

Valid options are:

     -C <col>
      Index of the attribute to be changed
      (default last attribute)

     -M
      Treat missing values as an extra value

     -P <num>
      Specify the percentage of values that are changed (default 10)

     -S <num>
      Specify the random number seed (default 1)

Version:
  $Revision: 14534 $
Author:
  Gabi Schmidberger (gabi@cs.waikato.ac.nz)
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AddNoise()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addNoise(Instances instances, int seed, int percent, int attIndex, boolean useMissing)`
  add noise to the dataset a given percentage of the instances are changed in the way that a set of instances are randomly selected using seed.
  `String`
  `attributeIndexTipText()`
  Returns the tip text for this property
  `boolean`
  `batchFinished()`
  Signify that this batch of input to the filter is finished.
  `String`
  `getAttributeIndex()`
  Get the index of the attribute used.
  `Capabilities`
  `getCapabilities()`
  Returns the Capabilities of this filter.
  `String[]`
  `getOptions()`
  Gets the current settings of the filter.
  `int`
  `getPercent()`
  Gets the size of noise data as a percentage of the original set.
  `int`
  `getRandomSeed()`
  Gets the random number seed.
  `String`
  `getRevision()`
  Returns the revision string.
  `int`
  `getSeed()`
  Gets the seed for the random number generations
  `boolean`
  `getUseMissing()`
  Gets the flag if missing values are treated as extra values.
  `String`
  `globalInfo()`
  Returns a string describing this filter
  `boolean`
  `input(Instance instance)`
  Input an instance for filtering.
  `Enumeration<Option>`
  `listOptions()`
  Returns an enumeration describing the available options
  `static void`
  `main(String[] argv)`
  Main method for testing this class.
  `String`
  `percentTipText()`
  Returns the tip text for this property
  `String`
  `randomSeedTipText()`
  Returns the tip text for this property
  `void`
  `setAttributeIndex(String attIndex)`
  Sets index of the attribute used.
  `boolean`
  `setInputFormat(Instances instanceInfo)`
  Sets the format of the input instances.
  `void`
  `setOptions(String[] options)`
  Parses a given list of options.
  `void`
  `setPercent(int newPercent)`
  Sets the size of noise data, as a percentage of the original set.
  `void`
  `setRandomSeed(int newSeed)`
  Sets the random number seed.
  `void`
  `setSeed(int seed)`
  Set the seed for random number generation.
  `void`
  `setUseMissing(boolean newUseMissing)`
  Sets the flag if missing values are treated as extra values.
  `String`
  `useMissingTipText()`
  Returns the tip text for this property

  ### Methods inherited from class weka.filters.Filter

  `batchFilterFile, debugTipText, doNotCheckCapabilitiesTipText, filterFile, getCapabilities, getCopyOfInputFormat, getDebug, getDoNotCheckCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, mayRemoveInstanceAfterFirstBatchDone, numPendingOutput, output, outputPeek, postExecution, preExecution, run, runFilter, setDebug, setDoNotCheckCapabilities, toString, useFilter, wekaStaticWrapper`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AddNoise

    public AddNoise()

- ## Method Details

  - ### globalInfo

    public String globalInfo()
    Returns a string describing this filter
    Returns:
      a description of the filter suitable for displaying in the explorer/experimenter gui

  - ### listOptions

    public Enumeration<Option> listOptions()
    Returns an enumeration describing the available options
    Specified by:
      `listOptions` in interface `OptionHandler`
    Overrides:
      `listOptions` in class `Filter`
    Returns:
      an enumeration of all the available options

  - ### setOptions

    public void setOptions(String[] options) throws Exception
    Parses a given list of options.

    Valid options are:

         -C <col>
          Index of the attribute to be changed
          (default last attribute)

         -M
          Treat missing values as an extra value

         -P <num>
          Specify the percentage of values that are changed (default 10)

         -S <num>
          Specify the random number seed (default 1)

    Specified by:
      `setOptions` in interface `OptionHandler`
    Overrides:
      `setOptions` in class `Filter`
    Parameters:
      `options` - the list of options as an array of strings
    Throws:
      `Exception` - if an option is not supported

  - ### getOptions

    public String[] getOptions()
    Gets the current settings of the filter.
    Specified by:
      `getOptions` in interface `OptionHandler`
    Overrides:
      `getOptions` in class `Filter`
    Returns:
      an array of strings suitable for passing to setOptions

  - ### useMissingTipText

    public String useMissingTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getUseMissing

    public boolean getUseMissing()
    Gets the flag if missing values are treated as extra values.
    Returns:
      the flag missing values.

  - ### setUseMissing

    public void setUseMissing(boolean newUseMissing)
    Sets the flag if missing values are treated as extra values.
    Parameters:
      `newUseMissing` - the new flag value.

  - ### randomSeedTipText

    public String randomSeedTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getRandomSeed

    public int getRandomSeed()
    Gets the random number seed.
    Returns:
      the random number seed.

  - ### setRandomSeed

    public void setRandomSeed(int newSeed)
    Sets the random number seed.
    Parameters:
      `newSeed` - the new random number seed.

  - ### setSeed

    @ProgrammaticProperty public void setSeed(int seed)
    Description copied from interface: `Randomizable`
    Set the seed for random number generation.
    Specified by:
      `setSeed` in interface `Randomizable`
    Parameters:
      `seed` - the seed

  - ### getSeed

    @ProgrammaticProperty public int getSeed()
    Description copied from interface: `Randomizable`
    Gets the seed for the random number generations
    Specified by:
      `getSeed` in interface `Randomizable`
    Returns:
      the seed for the random number generation

  - ### percentTipText

    public String percentTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getPercent

    public int getPercent()
    Gets the size of noise data as a percentage of the original set.
    Returns:
      the noise data size

  - ### setPercent

    public void setPercent(int newPercent)
    Sets the size of noise data, as a percentage of the original set.
    Parameters:
      `newPercent` - the subsample set size, between 0 and 100.

  - ### attributeIndexTipText

    public String attributeIndexTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### getAttributeIndex

    public String getAttributeIndex()
    Get the index of the attribute used.
    Returns:
      the index of the attribute

  - ### setAttributeIndex

    public void setAttributeIndex(String attIndex)
    Sets index of the attribute used.
    Parameters:
      `attIndex` - the index of the attribute

  - ### getCapabilities

    public Capabilities getCapabilities()
    Returns the Capabilities of this filter.
    Specified by:
      `getCapabilities` in interface `CapabilitiesHandler`
    Overrides:
      `getCapabilities` in class `Filter`
    Returns:
      the capabilities of this object
    See Also:
      - `Capabilities`

  - ### setInputFormat

    public boolean setInputFormat(Instances instanceInfo) throws Exception
    Sets the format of the input instances.
    Overrides:
      `setInputFormat` in class `Filter`
    Parameters:
      `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
    Returns:
      true if the outputFormat may be collected immediately
    Throws:
      `Exception` - if the input format can't be set successfully

  - ### input

    public boolean input(Instance instance) throws Exception
    Input an instance for filtering.
    Overrides:
      `input` in class `Filter`
    Parameters:
      `instance` - the input instance
    Returns:
      true if the filtered instance may now be collected with output().
    Throws:
      `Exception` - if the input format was not set

  - ### batchFinished

    public boolean batchFinished() throws Exception
    Signify that this batch of input to the filter is finished. If the filter requires all instances prior to filtering, output() may now be called to retrieve the filtered instances.
    Overrides:
      `batchFinished` in class `Filter`
    Returns:
      true if there are instances pending output
    Throws:
      `Exception` - if no input structure has been defined

  - ### addNoise

    public void addNoise(Instances instances, int seed, int percent, int attIndex, boolean useMissing)
    add noise to the dataset a given percentage of the instances are changed in the way that a set of instances are randomly selected using seed. The attribute given by its index is changed from its current value to one of the other possibly ones, also randomly. This is done while leaving the proportion the same. If m_UseMissing is true, missing value is used as a value of its own
    Parameters:
      `instances` - is the dataset
      `seed` - used for random function
      `percent` - percentage of instances that are changed
      `attIndex` - index of the attribute changed
      `useMissing` - if true missing values are treated as extra value

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Overrides:
      `getRevision` in class `Filter`
    Returns:
      the revision

  - ### main

    public static void main(String[] argv)
    Main method for testing this class.
    Parameters:
      `argv` - should contain arguments to the filter: use -h for help